#ifndef _AVL_H
#define _AVL_H

#ifdef __cplusplus
extern "C" {
#endif

typedef int (*AvlCmp)(void *,void *);
typedef int (*AvlTrav)(void *); 
typedef void (*AvlDest)(void *);

extern void *AvlInit(int (*)(void *,void *));
    /* accepts a comparison function and returns a tree identifier */
extern void *AvlInsert(void *,void *);
    /* accepts a tree identifier, and a user-data pointer */
    /* returns a user-data pointer if node exists, or 0 otherwise */
extern void *AvlDelete(void *,void *);
    /* accepts a tree identifier, and a user-data pointer */
    /* returns a user-data pointer if node exist(ed), or 0 otherwise */
extern int AvlTraverse(void *,int (*)(void *));
    /* accepts a tree identifier and a callback function */
    /* if the callback returns FALSE, traversal terminates, */
    /* and AvlTraverse also returns FALSE. */
extern void *AvlSearch(void *,void *);
    /* accepts a tree identifier and a user-data pointer */
    /* returns a user-data pointer if found, 0 otherwise */
extern void AvlDestroy(void *,void (*)(void *));
    /* accepts a tree identifier and a function accepting a user-data pointer */
    /* destroys the tree, calling the passed function on each node */

#ifdef __cplusplus
}
#endif

#endif
